Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.nwoods.jgo
Class JGoPen

    java.lang.Object
      com.nwoods.jgo.JGoPen

All Implemented Interfaces:
  JGoXMLSaveRestore, java.io.Serializable

public class JGoPen
extends java.lang.Object
implements java.io.Serializable, JGoXMLSaveRestore

Implements the concept of a drawing "pen", which determines the outline of a graphical figure. A pen has a "style" that can be one of the following values:

- SOLID - a solid stroke
- DASHED - a sequence of dashes
- DOTTED - a sequence of dots
- DASHDOT - a sequence alternating between dashes and dots
- DASHDOTDOT - a sequence of dash-dot-dots
- NONE - no drawing at all

A pen has a width and a color. Pens are immutable objects and thus may be shared freely.

Some commonly used pens are predefined:

- black - draw a black line
- darkGray - draw a dark gray line
- gray - draw a gray line
- lightGray - draw a light gray line
- white - draw a white line
- red - draw a red line
- magenta - draw a magenta line
- yellow - draw a yellow line
- green - draw a green line
- cyan - draw a cyan line
- blue - draw a blue line
- orange - draw a orange line
- pink - draw a pink line
- Null - don't draw a line at all

Serialized objects will not be compatible with future JGo releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of JGo.

See Also:
  `JGoDrawable`, `JGoBrush`, Serialized Form

Field Summary
`static JGoPen` | `black` a predefined solid black pen of width 1
`static JGoPen` | `blue` a predefined solid blue pen of width 1
`static int` | `CUSTOM` a custom, user-supplied Stroke
`static JGoPen` | `cyan` a predefined solid cyan pen of width 1
`static JGoPen` | `darkGray` a predefined solid dark gray pen of width 1
`static int` | `DASHDOT` a sequence alternating between dashes and dots
`static int` | `DASHDOTDOT` a sequence of dash-dot-dots
`static int` | `DASHED` a sequence of dashes
`static int` | `DOTTED` a sequence of dots
`static JGoPen` | `gray` a predefined solid gray pen of width 1
`static JGoPen` | `green` a predefined solid green pen of width 1
`static JGoPen` | `lightGray` a predefined solid light gray pen of width 1
`static JGoPen` | `magenta` a predefined solid magenta pen of width 1
`static int` | `NONE` no drawing at all
`static JGoPen` | `Null` a predefined pen that doesn't draw anything at all
`static JGoPen` | `orange` a predefined solid orange pen of width 1
`static JGoPen` | `pink` a predefined solid pink pen of width 1
`static JGoPen` | `red` a predefined solid red pen of width 1
`static int` | `SOLID` a solid stroke
`static JGoPen` | `white` a predefined solid white pen of width 1
`static JGoPen` | `yellow` a predefined solid yellow pen of width 1

Constructor Summary
`JGoPen()` Construct a pen that is a solid black line of width 1.
`JGoPen(int style, int width, java.awt.Color color)` Construct a pen with the given style, width, and color.
`JGoPen(java.awt.Stroke stroke, java.awt.Color color)` Construct a pen with the given stroke and color.

Method Summary
`java.awt.Color` | `getColor()` Get the color of the pen.
`java.awt.Stroke` | `getStroke()` Get the stroke used by the pen.
`int` | `getStyle()` Get the style of the pen.
`int` | `getWidth()` Get the width of the pen.
`static JGoPen` | `make(int style, int width, java.awt.Color color)` Return a JGoPen with the given characteristics.
`static JGoPen` | `makeStockPen(java.awt.Color color)` Create and return a pen that draws solidly with the given color with a line width of 1.
`void` | `SVGReadAttributes(DomElement svgElement)` This method will read attributes from standard SVG elements.
`DomNode` | `SVGReadObject(DomDoc svgDoc, JGoDocument jGoDoc, DomElement svgElement, DomElement jGoChildElement)` Read this object in from a DomDoc representing a Scalable Vector Graphics (SVG) XML document.
`void` | `SVGWriteAttributes(DomElement svgElement)` This method will add attributes to standard SVG elements.
`void` | `SVGWriteObject(DomDoc svgDoc, DomElement jGoElementGroup)` Write this object out to a DomDoc representing a Scalable Vector Graphics (SVG) XML document.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NONE

    public static final int NONE

  no drawing at all

  See Also:
    Constant Field Values

### SOLID

    public static final int SOLID

  a solid stroke

  See Also:
    Constant Field Values

### DASHED

    public static final int DASHED

  a sequence of dashes

  See Also:
    Constant Field Values

### DOTTED

    public static final int DOTTED

  a sequence of dots

  See Also:
    Constant Field Values

### DASHDOT

    public static final int DASHDOT

  a sequence alternating between dashes and dots

  See Also:
    Constant Field Values

### DASHDOTDOT

    public static final int DASHDOTDOT

  a sequence of dash-dot-dots

  See Also:
    Constant Field Values

### CUSTOM

    public static final int CUSTOM

  a custom, user-supplied Stroke

  See Also:
    Constant Field Values

### black

    public static final JGoPen black

  a predefined solid black pen of width 1

### darkGray

    public static final JGoPen darkGray

  a predefined solid dark gray pen of width 1

### gray

    public static final JGoPen gray

  a predefined solid gray pen of width 1

### lightGray

    public static final JGoPen lightGray

  a predefined solid light gray pen of width 1

### white

    public static final JGoPen white

  a predefined solid white pen of width 1

### red

    public static final JGoPen red

  a predefined solid red pen of width 1

### magenta

    public static final JGoPen magenta

  a predefined solid magenta pen of width 1

### yellow

    public static final JGoPen yellow

  a predefined solid yellow pen of width 1

### green

    public static final JGoPen green

  a predefined solid green pen of width 1

### cyan

    public static final JGoPen cyan

  a predefined solid cyan pen of width 1

### blue

    public static final JGoPen blue

  a predefined solid blue pen of width 1

### orange

    public static final JGoPen orange

  a predefined solid orange pen of width 1

### pink

    public static final JGoPen pink

  a predefined solid pink pen of width 1

### Null

    public static final JGoPen Null

  a predefined pen that doesn't draw anything at all

Constructor Detail

### JGoPen

    public JGoPen()

  Construct a pen that is a solid black line of width 1.

### JGoPen

    public JGoPen(int style,
                  int width,
                  java.awt.Color color)

  Construct a pen with the given style, width, and color.

Parameters:
  `style` - one of the constants such as SOLID or DASHED
  `width` - must be non-negative
  `color` - the color for the line

### JGoPen

    public JGoPen(java.awt.Stroke stroke,
                  java.awt.Color color)

  Construct a pen with the given stroke and color. The pen style will be CUSTOM.

Parameters:
  `stroke` - a user-supplied Stroke
  `color` - the color for the line

Method Detail

### makeStockPen

    public static JGoPen makeStockPen(java.awt.Color color)

  Create and return a pen that draws solidly with the given color with a line width of 1.

  For efficiency this may return an existing instance, rather than allocating a new one.

  Parameters:
    `color` - the color with which to draw
  Returns:
    a solid pen

### make

    public static JGoPen make(int style,
                              int width,
                              java.awt.Color color)

  Return a JGoPen with the given characteristics.

  For efficiency this may return an existing instance, rather than allocating a new one.

  Parameters:
    `style` - one of the constants such as SOLID or DASHED
    `width` - must be non-negative
    `color` - the color for the line

### getStyle

    public int getStyle()

  Get the style of the pen.

  Returns:
    the style of the pen.

### getWidth

    public int getWidth()

  Get the width of the pen.

  Returns:
    the width of the pen.

### getColor

    public java.awt.Color getColor()

  Get the color of the pen.

  Returns:
    the color of the pen.

### getStroke

    public java.awt.Stroke getStroke()

  Get the stroke used by the pen.

  Returns:
    the stroke used by the pen

### SVGWriteObject

    public void SVGWriteObject(DomDoc svgDoc,
                               DomElement jGoElementGroup)

  Description copied from interface: `JGoXMLSaveRestore`
  Write this object out to a DomDoc representing a Scalable Vector Graphics (SVG) XML document.

  This method will be called by com.nwoods.jgo.svg.DefaultDocument.SVGWriteDoc() for every JGoObject contained within a JGoDocument. The following example uses a JGoRectangle to illustrate the format of a generated SVG JGoObject:

  <g>
  <JGoClass class="com.nwoods.jgo.JGoRectangle"\>
  <rect height="75" style="stroke:black;stroke-width:1;fill:rgb(255,0,0);" width="75" x="65" y="71"/>
  <JGoClass class="com.nwoods.jgo.JGoDrawable" drawablebrush="jgoid1" drawablepen="jgoid2" embeddedpenbrush="false"/>
  <JGoClass class="com.nwoods.jgo.JGoObject" obj_flags="1054"/>
  </g>

  Note that the entire JGoObject is enclosed in a group (<g>). Each subclass of the JGoObject is described by a <JGoClass> element, starting with the most specific class and moving to the more general. Each <JGoClass> element has a "class" attribute which defines the class name. Each <JGoClass> element may also have several other attributes which uniquely describe that state of that class. Following the <JGoClass> element, each class may also genereate any other elements that are required, including representations of contained objects and standard SVG elements such as the <rect> element shown in the above example. The generation of SVG elements in the output makes it possible for the output to be read by SVG viewers and other SVG aware applications. The information contained in the <JGoClass> elements allows us to accurately save and restore all the information in a particular JGoObject subclass.

  If this class contains a reference to another object, call DomDoc.registerReferencingNode() to register that reference. This will cause the element representing the referenced object to be identified with a unique id attribute, and cause the element representing the referring object to have a user defined attribute containing a reference to that id. See DomDoc.registerReferencingNode() for more information.

  Typically, an implementation of this method will generate a <JGoClass> element using the DomDoc.createJGoClassElement() method, adding whatever attributes are necessary to describe the class. It will then call its superclass so that the superclass can add its own <JGoClass> element and other information to jGoElementGroup within the DomDoc.

  Refer to com.nwoods.jgo.examples.flower.ActivityNode.SVGWriteObject() and com.nwoods.jgo.examples.SimpleNode.SVGWriteObject() for examples using this method.

  Refer to the file com.nwoods.jgo.svg\xsvg.dtd for a formal description of JGo extensions to the SVG document type.

  Specified by:
    `SVGWriteObject` in interface `JGoXMLSaveRestore`
  Parameters:
    `svgDoc` - the DomDoc in which to construct the SVG representation of this object
    `jGoElementGroup` - the DomElement to which to attach this object
  See Also:
    `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`, `JGoObject.SVGWriteAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGUpdateReference(java.lang.String, java.lang.Object)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### SVGReadObject

    public DomNode SVGReadObject(DomDoc svgDoc,
                                 JGoDocument jGoDoc,
                                 DomElement svgElement,
                                 DomElement jGoChildElement)

  Description copied from interface: `JGoXMLSaveRestore`
  Read this object in from a DomDoc representing a Scalable Vector Graphics (SVG) XML document.

  This method will be called by com.nwoods.jgo.svg.DefaultDocument.SVGReadDoc() for every <JGoClass> element encountered in a DomDoc. First, an object of the type specified by the class attribute will be created and then the SVGReadObject() method will be called on that newly created object. Refer to SVGWriteObject() for a description of the expected format of the SVG document.

  This method may also be called by com.nwoods.jgo.svg.DefaultDocument.SVGReadDoc() when reading any SVG document, including those not generated by JGo and therefore not containing any <JGoClass> elements. In such cases, the DefaultDocument.SVGReadElement() method may be subclassed to examine the SVG element and cause the appropriate JGoObject to be created to represent that element and call SVGReadObject() on that newly created object. By default, standard JGoObjects such as JGoRectangles, JGoStrokes, etc will be created to represent these objects.

  If this class contains a reference to another object, call DomDoc.registerReferencingObject() to register that reference. This will cause the JGoObject.SVGUpdateReference() to be called on the referencing object after all the objects have been created, passing in the object befing referenced. See DomDoc.registerReferencingObject() for more information.

  Typically, an implementation of this method starts by verifying that the element being read is a <JGoClass> element (which will be true if jGoChildElement is not null). This will always be true unless you have subclassed the DefaultDocument.SVGReadElement() method as described above. It will then read the expected attributes of the <JGoClass> element (as written by SVGReadObject()), call SVGReadObject() on its superclass, and finally return the next element by calling svgElement.getNextSibling().

  Refer to com.nwoods.jgo.examples.flower.ActivityNode.SVGReadObject() and com.nwoods.jgo.examples.SimpleNode.SVGReadObject() for examples using this method.

  Specified by:
    `SVGReadObject` in interface `JGoXMLSaveRestore`
  Parameters:
    `svgDoc` - the DomDoc containing the SVG representation of this object
    `jGoDoc` - the JGoDocument in which this object was created
    `svgElement` - the element being read (typically the <g> element containing the JGoObject definition)
    `jGoChildElement` - the current <JGoClass> element being read withing the <g>
  See Also:
    `JGoObject.SVGWriteObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.DomElement)`, `JGoObject.SVGWriteAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGUpdateReference(java.lang.String, java.lang.Object)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### SVGWriteAttributes

    public void SVGWriteAttributes(DomElement svgElement)

  This method will add attributes to standard SVG elements.

  Call this method from SVGWriteObject() if standard SVG elements are generated by this class or if this class may be subclassed and it should contribute arguments to SVG elements. For example, the JGoDrawable class implements this method to add standard SVG attributes for stroke, fill, and width. The JGoRectangle class calls this method to add all appropriate attributes to the <rect> element it generates. It is not necessary to implement this method if this class does not contribute any attributes to standard SVG elements. It is not necessary to call this method from SVGWriteObject() if this class does not generate any standard SVG elements.

  Typically, an implementation of this method will first call the superclass and then call DomElement.setAttribute() to add attributes for this class.

  Parameters:
    `svgElement` - the DomElement to which to add attributes
  See Also:
    `JGoObject.SVGWriteObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`, `JGoObject.SVGWriteAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGUpdateReference(java.lang.String, java.lang.Object)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### SVGReadAttributes

    public void SVGReadAttributes(DomElement svgElement)

  This method will read attributes from standard SVG elements.

  Call this method from SVGReadObject() if standard SVG elements are being read by this class or if this class may be subclassed and it should read arguments from SVG elements. For example, the JGoDrawable class implements this method to read standard SVG attributes for stroke, fill, and width. The JGoRectangle class calls this method to read all appropriate attributes from the <rect> element it is reading. It is not necessary to implement this method if this class does not read any attributes from standard SVG elements. It is not necessary to call this method from SVGReadObject() if this class does not read any standard SVG elements.

  Typically, an implementation of this method will first call the superclass and then call DomElement.getAttribute() to read the attributes for this class.

  Parameters:
    `svgElement` - the DomElement from which to read attributes
  See Also:
    `JGoObject.SVGWriteObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`, `JGoObject.SVGWriteAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGUpdateReference(java.lang.String, java.lang.Object)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD